# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para peliculasaudiolatino
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "peliculasaudiolatino"
__category__ = "F"
__type__ = "generic"
__title__ = "Peliculasaudiolatino"
__language__ = "ES"
__creationdate__ = "20111014"

host = "http://peliculasaudiolatino.com"

def isGeneric():
    return True

def mainlist(item):
    logger.info("channels.peliculasaudiolatino mainlist")

    itemlist = []

    itemlist.append( Item( channel=__channel__, title="Buscar..." , action="search") )
    itemlist.append( Item( channel=__channel__, title="Estrenos", action="fichas", url=host + "/estrenos-2015.html" ) )
    itemlist.append( Item( channel=__channel__, title="Géneros", action="generos_years", url=host ) )
    itemlist.append( Item( channel=__channel__, title="Últimos años" , action="generos_years", url=host ) )
    itemlist.append( Item( channel=__channel__, title="Todas las películas", action="fichas", url=host + "/lista-completa.html" ) )
    itemlist.append( Item( channel=__channel__, title="Las más vistas", action="fichas", url=host + "/las-mas-vistas.html"))
    itemlist.append( Item( channel=__channel__, title="Últimas agregadas", action="fichas", url=host + "/ultimas-agregadas.html" ) )
    itemlist.append( Item( channel=__channel__, title="Recién actualizadas", action="fichas", url=host + "/recien-actualizadas.html" ) )
    itemlist.append( Item( channel=__channel__, title="Series TV", action="completo", url=host + "/series-completas.html", extra="fichas" ) )

    return itemlist

    return itemlist

def search( item, texto ):
    logger.info( "channels.peliculasaudiolatino search" )

    itemlist = []

    try:
        ## La web sólo hace búsquedas para las películas

        ## Búsqueda clásica (ERROR de paginación)
        #item.url = host + "/busqueda.php?q=" + texto

        ## Búsqueda no documentada o no presente en la web al usuario (Sin ERROR de paginación)
        item.url = host + "/search/" + texto.replace( '+', '%20' ) + ".html"
        item.extra = "fichas"

        ## Lista completa y ordenada de los resultados
        return completo( item )

    ## Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

def fichas( item ):
    logger.info("channels.peliculasaudiolatino peliculas")

    itemlist = []

    ## Descarga la página
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    ## Extrae los datos
    patron = '<div class="top">'
    patron+= '<a href="([^"]+)">'
    patron+= '<img src="([^"]+)"[^>]+></a>'
    patron+= '<div class="titup">([^<]+)</div>'
    patron+= '</div>'

    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl, scrapedthumbnail, scrapedtitle in matches:

        action = "findvideos"
        if item.title == "Series TV": action = "episodios"

        itemlist.append( Item( channel=__channel__, title=scrapedtitle, action=action, url=scrapedurl, thumbnail=scrapedthumbnail, fulltitle=scrapedtitle, show=scrapedtitle ) )

    ## Paginación
    next_page = scrapertools.find_single_match( data, '<a href="([^"]+)"><span class="icon-chevron-right"></span></a>' )
    if next_page!="":
        itemlist.append( Item( channel=__channel__, action="fichas", title=">> Página siguiente", url=next_page ) )

    return itemlist

def episodios( item ):
    logger.info("channels.peliculasaudiolatino peliculas")

    itemlist = []

    ## Descarga la página
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    ## Extrae los datos
    plot = scrapertools.get_match( data, '<div class="sinopsis"><p><b>Sinopsis:</b>([^<]+)</p></div>' ).decode( 'utf-8' ).encode( 'utf-8' )

    patron = "<ul><li>"
    patron+= "<a href='([^']+)'[^>]+>"
    patron+= "[^<]+<span[^/]+/span></a></li></ul>"

    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl in matches:

        temporada = scrapertools.get_match( scrapedurl, '/(\d+)/\d+\.html' )
        episodio = scrapertools.get_match( scrapedurl, '/\d+/(\d+)\.html' )
        if len(episodio) == 1: episodio = "0" + episodio
        title = temporada + "x" + episodio + " - " + item.title

        itemlist.append( Item( channel=__channel__, title=title, action="findvideos", url=scrapedurl, thumbnail=item.thumbnail, plot=plot, fulltitle=item.title, show=item.show ) )

        itemlist = sorted(itemlist, key=lambda Item: Item.title) 

    return itemlist

def generos_years(item):
    logger.info("channels.peliculasaudiolatino generos")

    itemlist = []

    ## Descarga la página
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    ## Extrae los datos 
    ## 0 = Géneros, 1 = Últimos años
    n = 0
    if item.title != "Géneros": n = 1

    data = scrapertools.get_match( data, '<ul class="children">(.*?)</ul>.*?<ul class="children">(.*?)</ul>' )[n]

    ## Se elimina Adulto +18 de Géneros
    if n == 0: data = data[:-1]

    patron = '<li><a href="([^"]+)">([^<]+)<span[^>]+></span></a></li>'

    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl, scrapedtitle in matches:

        itemlist.append( Item( channel=__channel__, action="fichas", title=scrapedtitle, url=host + scrapedurl ) )

    return itemlist

def findvideos(item):
    logger.info("channels.peliculasaudiolatino findvideos")

    itemlist = []

    ## Descarga la página
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    ## Extrae los datos
    plot = scrapertools.get_match( data, '<div class="sinopsis"><p><b>Sinopsis:</b>([^<]+)</p></div>' ).decode( 'utf-8' ).encode( 'utf-8' )
    thumbnail = scrapertools.get_match( data, '<img src="([^"]+)" width="250" height="350" alt=""/>' )

    url_youtube = scrapertools.find_single_match( data, '<iframe src="(https://www.youtube[^"]+)"' )
    if url_youtube != "":
        itemlist.append( Item( channel=__channel__, action="play", title="Trailer en YouTube", url=url_youtube, server="youtube", thumbnail=thumbnail, fulltitle=item.title, show=item.show, plot=plot, folder=False ) )

    ver = scrapertools.get_match( data, '<h1 class="respon">. Online</h1>.*?<tbody>(.*?)</tbody>' )
    descargar = scrapertools.get_match( data, '<h1 class="respon">. Descargar</h1>.*?<tbody>(.*?)</tbody>' )

    data = ver+descargar

    data = re.sub( r'javascript:void.0.;" style="cursor:pointer" onClick="window.open..|.,.mywindow.,.width=1000,height=800,location=no,status=no,scrollbars=yes,toolbar=no,menubar=no,directories=no..;', '', data )

    data = re.sub( r'<a href="([^"]+)" target="_blank">', r'<a href="\1">',data )

    patron = '<img[^>]+>(\d+)</th>' # nº orden
    patron+= '<th[^<]+<img src="([^"]+)"[^>]+>([^\.]+)\.[^<]+</th>' # thumbnail, server
    patron+= '<th[^<]+<img[^<]+</th><th[^<]+<img[^>]+>([^<]+)</th>' # calidad
    patron+= '<th[^<]+<div[^<]+<a href="([^"]+)">' # url
    patron+= '<span[^>]+>([^<]+)</span>' # title

    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapernorden, scrapedthumbnail, scrapedserver, scrapedcalidad, scrapedurl, scrapedtitle in matches:

        if len(scrapernorden) == 1: scrapernorden = "0" + scrapernorden

        title = scrapernorden + ". " + scrapedtitle + " en " + scrapedserver + " [" + scrapedcalidad + "]"

        itemlist.append( Item( channel=__channel__, action="play", title=title, url=scrapedurl, server=scrapedserver, thumbnail=thumbnail, fanart=scrapedthumbnail, fulltitle=item.title, show=item.show, plot=plot, folder=False ) )

    return itemlist

def play( item ):
    logger.info( "channels.peliculasaudiolatino play" )

    itemlist=[]

    ## Limpiar enlaces de descargas
    url = item.url.replace( 'http://peliculasaudiolatino.com/externo.php?host=', '' )

    if "peliculasaudiolatino" in url: ## Enlaces Online
        data = agrupa_datos( scrapertools.cache_page( item.url ) )
        url = scrapertools.get_match( data, 'vspace="0" src="([^"]+)"' )
        data = agrupa_datos( scrapertools.cache_page( url ) )

    else: ## Enlaces Descargas
        data = url

    itemlist = servertools.find_video_items(data=data)

    for videoitem in itemlist:
        videoitem.title = item.fulltitle
        videoitem.fulltitle = item.fulltitle
        videoitem.thumbnail = item.thumbnail
        videoitem.channel = __channel__

    return itemlist

## --------------------------------------------------------------------------------
## --------------------------------------------------------------------------------

## Agrupa los items de una función con paginación.
## item.extra debe contener en nombre de la función con
## paginación de la que se quiere agrupar los items.
def completo( item ):
    logger.info( "channels.peliculasaudiolatino completo" )

    itemlist = []

    ## Carga la primera página de items de la función contenida en item.extra
    exec "items_programas = " + item.extra + "( item )"
    if len( items_programas ) == 0: return []

    salir = False
    while not salir:

        ## Saca la URL de la siguiente página
        ultimo_item = items_programas[ len( items_programas )-1 ]

        ## Páginas intermedias
        if ultimo_item.action == item.extra:
            ## Quita el elemento de "Página siguiente" 
            ultimo_item = items_programas.pop()

            ## Añade los items de la página a la lista completa
            itemlist.extend( items_programas )
    
            ## Carga la sigiuente página
            exec "items_programas = " + item.extra + "( ultimo_item )"

        ## Última página
        else:
            ## Añade a la lista completa la última página y sale
            itemlist.extend( items_programas )
            salir = True

    ## Ordena la lista
    itemlist = sorted(itemlist, key=lambda Item: Item.title) 

    return itemlist

## Agrupa los datos
def agrupa_datos( data ):
    logger.info( "channels.peliculasaudiolatino agrupa_datos" )

    data = re.sub( r'\n|\r|\t|&nbsp;|<br>|<br/>|<br\s/>|<!--.*?-->', '', data )

    data = re.sub( r'\s+', ' ', data )

    data = re.sub( r'>\s<', '><', data )
    data = re.sub( r'>\s*([^<]+)\s*<', r'>\1<', data )

    data = re.sub( r'"\s"', '""', data )
    data = re.sub( r'="\s*([^"]+)\s*"', r'="\1"', data )

    data = re.sub( r"'\s'", "''", data )
    data = re.sub( r"='\s*([^']+)\s*'", r"='\1'", data )

    data = scrapertools.decodeHtmlentities( data )

    return data

## --------------------------------------------------------------------------------
## --------------------------------------------------------------------------------

# Verificación automática de canales: Esta función debe devolver "True" si está ok el canal.
def test():
    from servers import servertools
    
    # mainlist
    mainlist_items = mainlist(Item())
    # Da por bueno el canal si alguno de los vídeos de "Estrenos" devuelve mirrors
    estrenos_items = fichas(mainlist_items[0])
    bien = False
    for estrenos_item in estrenos_items:
        mirrors = findvideos( item=estrenos_item )
        if len(mirrors)>0:
            bien = True
            break

    return bien